package eu.openaire.urls_worker.controllers;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;


@RestController
@RequestMapping("")
public class GeneralController {

    private static final Logger logger = LoggerFactory.getLogger(GeneralController.class);


    public GeneralController() {}

    @GetMapping("isAlive")
    public ResponseEntity<?> isWorkerAlive() {

        logger.info("Received an \"isAlive\" request.");

        return ResponseEntity.ok().build();
    }


    @GetMapping("getHandledAssignmentsCounts")
    public ResponseEntity<?> getHandledAssignmentsCounts()
    {
        List<Long> handledAssignmentsCounts = new ArrayList<>(FullTextsController.assignmentsNumsHandledAndLocallyDeleted.size()/2);
        for ( Map.Entry<Long,Boolean> entry : FullTextsController.assignmentsNumsHandledAndLocallyDeleted.entrySet() )
        {
            if ( entry.getValue().equals(true) )
                handledAssignmentsCounts.add(entry.getKey());
        }
        return ResponseEntity.ok(handledAssignmentsCounts);
    }

}
